/////////////////////////////////////////////////////////////////////////////////////////////////
// object for the comments for this application, to be used by dynamicViewer
commentObj = {
  height:270,
  width:436,
  autoExpandColumn: 'expand',
  Comment: Ext.data.Record.create([
           {name: 'tag', type: 'string'},
           {name: 'val', type: 'string'},
           {name: 'context', type: 'string'}
    ]),
  storeFields: {
        fields: [
           {name: 'tag'}, {name: 'val'}, {name: 'context'}
        ]
    },
  comUrl: BMS.AG.ML.IMVConfig.editURL,
  // unfortunately we can't share ColumnModel object because we need a fresh editor every time!!
  getColModel: function()
  {
    var colModel = new Ext.grid.ColumnModel({
      columns: [
         {
           id:'context',
           header: "Context",
           dataIndex: 'context',
           width: 80
         },
         {
           header: "Tag",
           dataIndex: 'tag',
           width: 80
         },
         {
           header: "Value",
           id: 'expand',
           dataIndex: 'val',
           width: 230,
           sortable: false,
           editor: new Ext.form.TextField({allowBlank: false})
         }
      ],
      defaults: { sortable: true }
    });
    return colModel;
  },
  getComVals: function(tag, context)
  {
    var c = new Array();
    if(dynamicViewer && dynamicViewer.comments && dynamicViewer.comments.row)
    {
      var coms = dynamicViewer.comments.row, d = {};
      for(var id in coms)
      {
        for(var i = 0; i < coms[id].length; i++)
        {
          var track = dynamicViewer.trackManager.getTrack(id);
          if(track && track.noDisplay()) continue;
          var com = coms[id][i];
          if(com[0] == tag) // com[2] == context doesn't work well
          {
            if(!d[com[1]]) c.push(com[1]);
            d[com[1]] = 1;
          }
        }
      }
    }
    return (filterObj.fieldTypes[tag] == 'number')? c.sort(function(a,b){return a-b}) : c.sort();
  },
  // make sure we give a fresh object every time!
  getInitComValue: function(context)
  {
    return {context:context || 'Myself',tag:'Comment',val:'This '};
  },
  // com format: [type][id]:[tag,val,context]
  // datacom format: [tag][context] = val array
  updateComment: function(e, info, com, datacom, currentUser)
  {
    var old = e.originalValue, newd = e.record.data, found = false, type = 'settag'; // type defaults to 'add'
    // we need to check if com has old data, if so, update it to new; if not (old data is "This "), add the new one
    var d = info.type == 'row'? com.row[info.track.id] : info.type == 'col'? com.col[info.track.id+'::'+info.tstart] : com.cell[info.track.id+'::'+info.tstart];
    if(d && old)
    {
      for(var i = 0; i < d.length; i++)
        if(d[i][0] == newd.tag && d[i][1] == old && d[i][2] == newd.context)
        {
          d[i][1] = newd.val;
          found = true;
          type = 'settag'; // 'update'
          break;
        }
    }
    if(!found)
    {
      if(!d)
      {
        d = new Array();
        if(info.type == 'row') com.row[info.track.id] = d;
        else if(info.type == 'col') com.col[info.track.id+'::'+info.tstart] = d;
        else com.cell[info.track.id+'::'+info.tstart] = d;
      }
      d.push([newd.tag,newd.val,newd.context]);
    }
    // do the same for datacom now
    if(!datacom[newd.tag]) datacom[newd.tag] = {};
    found = false;
    d = datacom[newd.tag][newd.context];
    if(d && old)
    {
      for(var i = 0; i < d.length; i++)
      {
        if(d[i] == old)
        {
          d[i] = newd.val;
          found = true;
          break;
        }
      }
    }
    if(!found)
    {
      if(!d) d = new Array();
      d.push(newd.val);
    }
    datacom[newd.tag][newd.context] = d;
    // now update DB
    var self = this, pos = info.tstart;
    if(this.comUrl)
    {
      var para = { agent:'imb', mode:type, type:info.type, id:info.track.id, position:pos, tagname:newd.tag, tagvalue:newd.val };
      if(dynamicViewer && dynamicViewer.timestamp) para.timestamp = dynamicViewer.timestamp;
      if(newd.context != currentUser) para.tagcontext = newd.context; // Charles said do not send in currentUser to his program
        Ext.Ajax.request({
           url: this.comUrl,
           callback: function(o, s, r) { self.checkUpdateResult.call(self, o, s, r, type, info) },
           params: para
        });
    }
    if(logger) logger.add('Comment', 'For ' + info.track.name + ', ' + (info.type == 'row'?'':'position ' + pos + ', ') + 'update ' + info.type + ' comment: (' + newd.tag + ', ' + newd.val + ')');
  },
  checkUpdateResult: function(opt, suc, resp, type, info)
  {
    var reason = ' Reason:Server error';
    if(suc)
    {
      // check response to really tell if it's successful
      var r = Ext.util.JSON.decode(resp.responseText);
      if(typeof(r) == 'object')
      {
        if(!r.error) return;
        else reason = ' Reason:' + r.error.join(',');
      }
      else reason = ' Reason:Update script error';
    }
    BMS.AG.ML.Util.alert('Error','Failed to commit your change to the '+ info.type + ' comment for ' + (info.track.name || info.track.id) + ' in DB!\n\nAs a result, the comment is only changed in the viewer (not in the DB backend!)\nYou would need to contact the Bioinfo team for help with the DB.');
  },
  removeComment: function(record, info, com, datacom)
  {
    var rd = record.data, type = 'deletetag';
    var d = info.type == 'row'? com.row[info.track.id] : info.type == 'col'? com.col[info.track.id+'::'+info.tstart] : com.cell[info.track.id+'::'+info.tstart];
    // needed for cases where user did not modify the new placeholder comment at all
    if(!d) return;
    for(var i = 0; i < d.length; i++)
    {
      if(d[i][0] == rd.tag && d[i][1] == rd.val && d[i][2] == rd.context)
      {
        d.splice(i, 1);
        break;
      }
    }
    // do the same for datacom now
    if(!datacom[rd.tag]) datacom[rd.tag] = {};
    d = datacom[rd.tag][rd.context];
    if(!d) return;
    for(var i = 0; i < d.length; i++)
    {
      if(d[i] == rd.val)
      {
        d.splice(i, 1);
        break;
      }
    }
    datacom[rd.tag][rd.context] = d;
    // now update DB
    var self = this, pos = info.tstart;
    if(this.comUrl)
    {
      var para = { agent:'imb', mode:type, type:info.type, id:info.track.id, position:pos, tagname:rd.tag, tagcontext:rd.context, tagvalue:rd.val };
      if(dynamicViewer && dynamicViewer.timestamp) para.timestamp = dynamicViewer.timestamp;
      Ext.Ajax.request({
         url: this.comUrl,
         callback: function(o, s, r) { self.checkUpdateResult.call(self, o, s, r, type, info) },
         params: para
      });
    }
    if(logger) logger.add('Comment', 'For ' + info.track.name + ', ' + (info.type == 'row'?'':'position ' + pos + ', ') + 'remove ' + info.type + ' comment: (' + rd.tag + ', ' + rd.val + ')');
  }
}